; GPAdemo - GetProcAddr demo by Vortex

.386
.model flat,stdcall
option casemap:none

include     \GeneSys\include\windows.inc
include     \GeneSys\include\kernel32.inc

GetProcAddr PROTO hModule:DWORD,lpProcName:DWORD

includelib  \GeneSys\lib\kernel32.lib
includelib  \GeneSys\GSLib\GeneSys.lib


.data
user32      db 'user32.dll',0
MsgBoxFunc  db 'MessageBoxA',0
caption     db 'Hello',0
message     db 'Retrieving the address of MessageBoxA',13,10
            db 'with GetProcAddr',0

.code

start:

    invoke  LoadLibrary,ADDR user32 ;   load user32.dll
    push    eax                     ;   reserve the value of eax for FreeLibrary
    invoke  GetProcAddr,eax,ADDR MsgBoxFunc
    push    MB_OK
    push    OFFSET caption
    push    OFFSET message
    push    0
    call    eax                     ;   eax holds the address of MessageBoxA
    call    FreeLibrary
    invoke  ExitProcess,0

END start